// Code generated by go-swagger; DO NOT EDIT.

package variables

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewSetNamespaceVariableParams creates a new SetNamespaceVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSetNamespaceVariableParams() *SetNamespaceVariableParams {
	return &SetNamespaceVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSetNamespaceVariableParamsWithTimeout creates a new SetNamespaceVariableParams object
// with the ability to set a timeout on a request.
func NewSetNamespaceVariableParamsWithTimeout(timeout time.Duration) *SetNamespaceVariableParams {
	return &SetNamespaceVariableParams{
		timeout: timeout,
	}
}

// NewSetNamespaceVariableParamsWithContext creates a new SetNamespaceVariableParams object
// with the ability to set a context for a request.
func NewSetNamespaceVariableParamsWithContext(ctx context.Context) *SetNamespaceVariableParams {
	return &SetNamespaceVariableParams{
		Context: ctx,
	}
}

// NewSetNamespaceVariableParamsWithHTTPClient creates a new SetNamespaceVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewSetNamespaceVariableParamsWithHTTPClient(client *http.Client) *SetNamespaceVariableParams {
	return &SetNamespaceVariableParams{
		HTTPClient: client,
	}
}

/* SetNamespaceVariableParams contains all the parameters to send to the API endpoint
   for the set namespace variable operation.

   Typically these are written to a http.Request.
*/
type SetNamespaceVariableParams struct {

	/* Data.

	   Payload that contains variable data.
	*/
	Data string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Variable.

	   target variable
	*/
	Variable string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the set namespace variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SetNamespaceVariableParams) WithDefaults() *SetNamespaceVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the set namespace variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SetNamespaceVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the set namespace variable params
func (o *SetNamespaceVariableParams) WithTimeout(timeout time.Duration) *SetNamespaceVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the set namespace variable params
func (o *SetNamespaceVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the set namespace variable params
func (o *SetNamespaceVariableParams) WithContext(ctx context.Context) *SetNamespaceVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the set namespace variable params
func (o *SetNamespaceVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the set namespace variable params
func (o *SetNamespaceVariableParams) WithHTTPClient(client *http.Client) *SetNamespaceVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the set namespace variable params
func (o *SetNamespaceVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithData adds the data to the set namespace variable params
func (o *SetNamespaceVariableParams) WithData(data string) *SetNamespaceVariableParams {
	o.SetData(data)
	return o
}

// SetData adds the data to the set namespace variable params
func (o *SetNamespaceVariableParams) SetData(data string) {
	o.Data = data
}

// WithNamespace adds the namespace to the set namespace variable params
func (o *SetNamespaceVariableParams) WithNamespace(namespace string) *SetNamespaceVariableParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the set namespace variable params
func (o *SetNamespaceVariableParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithVariable adds the variable to the set namespace variable params
func (o *SetNamespaceVariableParams) WithVariable(variable string) *SetNamespaceVariableParams {
	o.SetVariable(variable)
	return o
}

// SetVariable adds the variable to the set namespace variable params
func (o *SetNamespaceVariableParams) SetVariable(variable string) {
	o.Variable = variable
}

// WriteToRequest writes these params to a swagger request
func (o *SetNamespaceVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Data); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param variable
	if err := r.SetPathParam("variable", o.Variable); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
